var reseller_id;
/*
 * New customer do sign up
 */
function newCustomerSignUp(result) {
    dataLayer.push({
        "event": "Customer Signup",
        "resellerid": result.data.login_info.reseller_id,
        "customerid": result.data.login_info.customer_id
    });
}

/*
 * Customer do login or sign up from checkout page
 */
function checkoutLoginSignUp(result) {
    var dataLayerActionOption = (Cookies['identify_gtm_action'] == "login") ? "sign in" : "sign up";
    dataLayer.push({
        'event': 'checkout',
        'ecommerce': {
            'currencyCode': result.data.currency_code,
            'checkout': {
                'actionField': {
                    'step': 1,
                    'option': 'login'
                },
                'products': result.data.ecommerce_items
            }
        }
    });

    dataLayer.push({
        'event': 'checkoutOption',
        'ecommerce': {
            'checkout_option': {
                'actionField': {
                    'step': 1,
                    'option': dataLayerActionOption
                }
            }
        }
    });
}

/*
 * The code should be called every time when the user lands on the checkout page
 * */
function dataLayerAddToCart() {

    $.ajax({
        type: "GET",
        url: $.url("/api/gtm/data"),
        dataType: 'json',
        success: function(result) {
            dataLayer.push({
                "event": "Checkout",
                "resellerid": result.data.login_info.reseller_id,
                "orderDetails": {
                    "cart_details": result.data.cart_items,
                    "resellerid": result.data.login_info.reseller_id,
                }
            });

            if (sessionStorage.addToCartTriggered == undefined) {
                dataLayer.push({
                    'event': 'addToCart',
                    'ecommerce': {
                        'currencyCode': result.data.currency_code,
                        'add': {
                            'products': result.data.ecommerce_items
                        }
                    }
                });
                sessionStorage.setItem('addToCartTriggered', true);
            }
            sessionStorage.setItem('products_item', JSON.stringify(result.data.ecommerce_items));
        }
    });
}

/*
 * This code is implemented on cart page.
 * The code should be called every time someone clicks on the remove from cart cross button.
 * */
function dataLayerRemoveFromCart(msg) {
    dataLayer.push({
        'event': 'removeFromCart',
        'ecommerce': {
            'currencyCode': msg.ecommerce_items.currency_code,
            'remove': {
                'products': msg.ecommerce_items.products
            }
        }
    });
}

/*
 * The below code is for tracking checkout steps.
 * This code is implemented on the checkout steps after the cart page like login, payment, etc.
 * The code should be called every time someone proceeds to the next step throughout the checkout process
 * checkoutLoginSignUp() this function is part of Measuring Checkout Steps
 * */
function dataLayerMeasuringCheckout() {
    dataLayer.push({
        'event': 'checkout',
        'ecommerce': {
            'currencyCode': $.trim($("#current_selected_currency").text()),
            'checkout': {
                'actionField': {
                    'step': 2,
                    'option': 'payment'
                },
                'products': (!!sessionStorage.getItem('products_item')) ? JSON.parse(sessionStorage.getItem('products_item')) : []
            }
        }
    });

    dataLayer.push({
        'event': 'checkoutOption',
        'ecommerce': {
            'checkout_option': {
                'actionField': {
                    'step': 2,
                    'option': sessionStorage.getItem('payment_method')
                } //paymentOption chosen
            }
        }
    });
}

/*
 * The below code is for tracking final purchases.
 * This code is implemented on the order success page.
 * The code is called every time someone the checkout success page after payment completion.
 * */
function dataLayerPurchase(result) {
    try {
        dataLayer.push({
            'event': 'transaction',
            'ecommerce': {
                'currencyCode': result.data.currency_code,
                'purchase': {
                    'actionField': {
                        'id': result.data.cart_id, // Cart ID.
                        'affiliation': getResellerId(),
                        'revenue': result.data.payment_info.conversion_amount, // Total transaction value (incl. tax and shipping)
                        'tax': result.data.payment_info.conversion_tax,
                        'coupon': result.data.payment_info.coupon_code
                    },
                    'products': result.data.ecommerce_items
                }
            }
        });

        sessionStorage.removeItem("products_item");
        sessionStorage.removeItem("originaluserId");
        sessionStorage.removeItem("addToCartTriggered");
    } catch (e) {
        console.log(e);
    }
}

$(document).ready(function() {
    /*
     * This dataLayer is pushed when
     * 1) New customer do sign up
     * 2) Customer do login or sign up from checkout page
     * */
    if (!!Cookies['identify_gtm_action']) {
        $.ajax({
            type: "GET",
            url: $.url("/api/gtm/data"),
            dataType: 'json',
            success: function(result) {
                var identify_gtm_action = Cookies['identify_gtm_action'];
                if (identify_gtm_action == "newcustomer") {
                    /*
                     * 1) New customer do sign up
                     */
                    newCustomerSignUp(result);
                } else if (identify_gtm_action == "login" || identify_gtm_action == "signup") {
                    /*
                     * 2) Customer do login or sign up from checkout page
                     */
                    checkoutLoginSignUp(result);
                }
                Cookies.erase('identify_gtm_action');
            }
        });
    }
});

/*
 * addToCartTriggered is used indentify whether the addToCart dataLayer event is triggered or not.
 * if the triggered and page is refreshed then it will not trigger again.
 * if navigated to other page addToCartTriggered will get removed.
 * */
var isCheckoutPage = (window.location.pathname.replace(/^\/+/, '').replace('.php', '').toLocaleLowerCase() == "checkout") ? true : false;
if (sessionStorage.originaluserId != undefined && !isCheckoutPage) {
    sessionStorage.removeItem("addToCartTriggered");
}


function dataLayerDomainsList() {
    try {
        var impression = [];

        _.each(primaryDomainList.models, function(value) {
            var domain_type = getDomainType(value.attributes);
            impression.push(setItemsDomain(value, domain_type));
        });

        _.each(domainsList.models, function(value) {
            var domain_type = getDomainType(value.attributes);
            impression.push(setItemsDomain(value, domain_type));
        });

        dataLayerImpressionDomains(impression);
    } catch (e) {
        console.log(e);
    }
}

function getDomainType(valueObj) {
    var domainType = "";
    if (valueObj.premium || valueObj.newgtld_premium) {
        domainType = "premium";
    } else if (!!valueObj.phase && valueObj.phase == "prega") {
        domainType = "Pre-Register Now";
    }

    if (valueObj.rank == "1") {
        domainType = domainType + " primary";
        domainType = domainType.trim();
    }

    if (domainType === null || domainType === '') {
        domainType = "normal";
    }
    return domainType;
}

function setItemsDomain(value, domain_type) {
    item = {}
    item['name'] = domain_type;
    item['price'] = (value.get("status") == "available") ? value.get("price") : 0;
    item['category'] = "domorder";
    item['variant'] = value.get("tld");
    item['list'] = (dca.user_input.domain_titles.indexOf(value.get("name").split('.')[0]) !== -1) ? "Exact Match Yes" : "Exact Match No";
    item['position'] = value.get("rank");
    item['dimension13'] = (!!value.get("classkey")) ? value.get("classkey") : "";
    item['dimension14'] = value.get("name"); // Domain Name
    item['dimension18'] = value.get("dcasource");
    item['dimension19'] = getResellerId();
    return item;
}

/*
 * The below code is for tracking domain impressions.
 * Only the domains list on the screen are to be passed.
 * */
function dataLayerImpressionDomains(impression) {
    dataLayer.push({
        'event': 'impressions',
        'ecommerce': {
            'currencyCode': $.trim($("#current_selected_currency").text()),
            'impressions': impression
        }
    });
}

/*
 * The code below should be triggered when the user clicks on the "Select" button against a given Domain name suggestion.
 * */
function dataLayerDomainSelected(selectedDomainObj) {
    try {
        dataLayer.push({
            'event': 'product details',
            'ecommerce': {
                'detail': {
                    'actionField': {
                        'list': (dca.user_input.domain_titles.indexOf(selectedDomainObj.name.split('.')[0]) !== -1) ? "Exact Match Yes" : "Exact Match No"
                    },
                    'products': [{
                        'name': getDomainType(selectedDomainObj),
                        'price': selectedDomainObj.price,
                        'category': 'domorder',
                        'variant': selectedDomainObj.tld,
                        'dimension13': (selectedDomainObj.classkey != undefined) ? selectedDomainObj.classkey : "",
                        'dimension14': selectedDomainObj.name,
                        'dimension18': selectedDomainObj.dcasource,
                        'dimension19': getResellerId()
                    }]
                }
            }
        });
    } catch (e) {
        console.log(e);
    }
}

var gtmProductViewObject = {};
resetGtmProductViewObjectData();

function resetGtmProductViewObjectData() {
    gtmProductViewObject = {
        'plan_name': '',
        'plan_id': '',
        'price': '',
        'category': '',
        'location': '',
        'product_key': '',
        'domain_name': '',
        'dimension18': '',
        'reseller_id': getResellerId()
    }
}

function dataLayerProductView(gtmProductViewObject) {
    dataLayer.push({
        'event': 'product details',
        'ecommerce': {
            'detail': {
                'actionField': {
                    'list': gtmProductViewObject.category
                },
                'products': [{
                    'name': gtmProductViewObject.plan_name,
                    'id': gtmProductViewObject.plan_id,
                    'price': gtmProductViewObject.price,
                    'category': gtmProductViewObject.category,
                    'variant': gtmProductViewObject.location,
                    'dimension13': gtmProductViewObject.product_key,
                    'dimension14': gtmProductViewObject.domain_name,
                    'dimension18': gtmProductViewObject.dimension18,
                    'dimension19': gtmProductViewObject.reseller_id
                }]
            }
        }
    });
}

function getTextFromElement($element, is_price = false) {
    try {
        var textValue = $element.clone().children().remove().end().text();
        if (is_price) {
            textValue = textValue.replace('/', '')
                .replace('mo', '')
                .replace('Rs.', '')
                .replace('Rs', '')
                .replace('₽', '')
                .replace('AUD', '')
                .replace('CAD', '')
                .replace('$', '')
                .replace('TRY', '')
                .replace('¥', '')
                .replace('£', '')
                .replace('€', '');
        }
        return (!!textValue) ? textValue : "";
    } catch (e) {
        console.log(e);
        return "";
    }

}

function productViewClick(element) {
    $(element).click(function() {
        try {
            resetGtmProductViewObjectData();
            var $elem = $(this).closest("form");
            var form_name = $($elem).attr("name");
            var category = $($elem).find("input[name='category']").val();
            var type = $($elem).find("input[name='type']").val();
            var location = $($elem).find("input[name='location']").val();
            var domain_name = $($elem).find("input[name='domain_name']").val();
            var productkey = $($elem).find("input[name='productkey']").val();
            var plan_name = $($elem).find("li.name span.pname").text();
            var planid = $($elem).find("input[name='planid']").val();
            var duration = $($elem).find("input[name='duration']").val();
            duration = (!!duration) ? duration : '';
            var email_account_range = $($elem).find("input[name='email_account_range']").val();
            email_account_range = (!!email_account_range) ? email_account_range : '';

            if (form_name == "wordpresshosting") {
                planid = $($elem).find("input[name='plan_id']").val();
            }

            if (!!category) {
                type = category;
            }

            gtmProductViewObject = {
                'plan_name': (!!plan_name) ? plan_name : '',
                'plan_id': (!!planid) ? planid : '',
                'price': '',
                'category': (!!type) ? type : '',
                'location': (!!location) ? location : '',
                'product_key': (!!productkey) ? productkey : '',
                'domain_name': (!!domain_name) ? domain_name : '',
                'dimension18': '',
                'reseller_id': getResellerId()
            }

            $.ajax({
                type: "GET",
                url: $.url("/api/gtm/productdetails"),
                data: "category=" + gtmProductViewObject.category + "&country=" + gtmProductViewObject.location + "&plan_id=" + gtmProductViewObject.plan_id + "&product_key=" + gtmProductViewObject.product_key + "&duration=" + duration + "&email_account_range=" + email_account_range,
                dataType: 'json',
                success: function(result) {
                    if (!!result && !!result.data && !!result.data.product_details) {
                        gtmProductViewObject.product_key = result.data.product_details.product_key;
                        gtmProductViewObject.price = result.data.product_details.plan_price;
                        gtmProductViewObject.plan_name = result.data.product_details.plan_name;
                        if (gtmProductViewObject.category == "") {
                            gtmProductViewObject.category = result.data.product_details.category;
                        }
                    }
                    dataLayerProductView(gtmProductViewObject);
                }
            });
        } catch (e) {
            console.log(e);
        }
    });
}

/*
 * 1) Hosting -> Linux Shared Hosting
 * 2) Hosting -> Windows Shared Hosting
 * 3) Hosting -> Linux Reseller Hosting
 * */
productViewClick("form[name='hostingplan'] li.p-button a.txt-button");

/*
 * 1) Hosting -> Windows Reseller Hosting
 * */
productViewClick("form[name='hostingplan'] li.p-button button.txt-button");

/*
 * 1) Hosting -> WordPress Hosting
 * */
productViewClick("form[name='wordpresshosting'] ul li input[type='submit']");

/*
 * 1) Hosting -> VPS
 * */
productViewClick("form[name^='vpshosting_vps_'] table.pricing-tbl td a.txt-button");

/*
 * 1) Hosting -> Linux KVM VPS
 * */
productViewClick("form[name='virtualserverlinuxplan'] li.p-button button");

/*
 * 1) Hosting -> Dedicated Servers (Linux)
 * */
productViewClick("form[name='dedicatedserverplan'] div.select_plan button");

/*
 * 1) Hosting -> Windows Dedicated Servers
 * 2) Hosting -> Bare Metal Linux Servers
 * 3) Hosting -> Bare Metal Windows Servers
 * 4) Hosting -> Managed Servers
 * */
productViewClick("form[name='dedicatedserverplan'] li.p-button button.txt-button");

/*
 * 1) Hosting -> Codeguard Website Backup
 * 2) Security -> Codeguard Website Backup
 * */
productViewClick("form[name='codeguard'] button.cog-buybutton");

/*
 * 1) Hosting -> Sitelock Malware Detector
 * 2) Security -> Sitelock
 * */
productViewClick("form[name='sitelock'] td input[type='button'].green-button");

/*
 * 1) Email -> Businesses Email
 * */
productViewClick("form[name='enterpriseemail_lite_form'] div.ee-lite-submit-wrapper a.ui-button");

/*
 * 1) Email -> Enterprise Email
 * */
productViewClick("form[name='enterpriseemail_form'] div.buy-button-wrapper a.ui-button");

/*
 * 1) Security -> SSL Certificates
 * */
productViewClick("form[name='sslcert'] .plan-block a.ui-button2");

/*
 * 1) Combo Offers
 * */
productViewClick("form[name='productbundleplan'] div.bundles-price input.bundles-green-button");

/*
 * 1) Cloud
 * */
productViewClick("form[name='cloudsites_form'] li a.green-button-style");

/*
 * 1) Websites - Website Builder
 * */
productViewClick("form[name='sitebuilderplan'] li.p-button a.txt-button");

/*
 * 1) Websites - Weebly
 * */
$("table.weebly-plans-pricing tr.weebly-buy-buttons td input[type='button']").click(function(e) {
    productViewClick("form[name='weebly'] input[name='type']");
    $("form[name='weebly'] input[name='type']").trigger("click");
});

/*
 * 1) Websites - Impress.ly
 * */
$("table.impress-plans-content tr td input[type='button']").click(function(e) {
    productViewClick("form[name='impressly'] input[name='type']");
    $("form[name='impressly'] input[name='type']").trigger("click");
});



function dataLayerCustomerLogin() {
    $.ajax({
        type: "GET",
        url: $.url("/api/gtm/data"),
        dataType: 'json',
        success: function(result) {
            dataLayer.push({
                "event": "Customer Login",
                "resellerid": result.data.login_info.reseller_id,
                "customerid": result.data.login_info.customer_id,
                "login_details": {
                    "resellerid": result.data.login_info.reseller_id,
                    "customerid": result.data.login_info.customer_id,
                }
            });
        }
    });
}

function dataLayerOrderPlaced(result) {
    dataLayer.push({
        "event": "Order Placed",
        "resellerid": result.data.login_info.reseller_id,
        "orderDetails": {
            "login_details": result.data.login_info,
            "cart_details": result.data.cart_items,
            "payment_method": sessionStorage.getItem('payment_method'),
            "payment_details": result.data.payment_info,
        }
    });
}


function gtmDataLayerDomainSelected(selected_domains_array) {
    dataLayer.push({
        "event": "Domains selected",
        "selectedDomains": {
            "selected_domains": selected_domains_array
        },
        "resellerid": getResellerId(),
    });
}


function dataLayerDomainSearched(numberOfSearches, keywords, tlds, exact_match) {
    dataLayer.push({
        "event": "Domains searched",
        "searchDetails": {
            "number_of_searches": numberOfSearches,
            "keywords_searched": keywords,
            "tlds_searched": tlds,
            "exact_match_found": exact_match,
        },
        "resellerid": getResellerId(),
    });
}


function dataLayerAutoRenewCartItemUpdate(result) {
    dataLayer.push({
        "event": "Cart item auto renew update",
        "cart_details": result.data.cart_items
    });
}

function dataLayerDurationUpdated(result) {
    dataLayer.push({
        "event": "Cart item duration update",
        "cart_details": result.data.cart_items
    });
}


function getResellerId() {
    try {
        if (typeof reseller_id != "undefined") {
            return reseller_id;
        } else {
            return "";
        }
    } catch (e) {
        console.log(e);
    }
}